#   Copyright (c) 2011, Canonical Ltd
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  
from StringIO import StringIO
import sys

import bson
import web

expected_texts = {}

class expected:
    def POST(self):
        expected_result = bson.loads(web.data())
        expected_texts[expected_result['expected-text']] = expected_result
        del expected_result['expected-text']
        return ''


class verify:
    def POST(self):
        text = web.data()
        result = expected_texts.pop(text, None)
        if not result:
            raise web.webapi.internalerror("(7, 58, 'No data')")
        return bson.dumps(result)

urls = (
  '/', 'verify',
  '/expected', 'expected',
  )

def patch_dynamic_port():
    """Setup better handling of dynamically allocated ports."""
    def runsimple(func, server_address=("0.0.0.0", 8080)):
        """ 
        Runs [CherryPy][cp] WSGI server hosting WSGI app `func`.  
        The directory `static/` is hosted statically. 
     
        [cp]: http://www.cherrypy.org 
        """ 
        func = web.httpserver.StaticMiddleware(func) 
        func = web.httpserver.LogMiddleware(func) 
         
        server = WSGIStartupPrintingServer(server_address, func,
                server_name="localhost")
        # disabled because until start is called the port is not known.
        # print "http://%s:%d/" % server_address 
        try: 
            server.start() 
        except KeyboardInterrupt: 
            server.stop() 
    web.httpserver.runsimple = runsimple

    from web.wsgiserver import CherryPyWSGIServer
    class WSGIStartupPrintingServer(CherryPyWSGIServer):
        """Overridden to print the startup address."""
        def bind(self, family, type, proto=0):
            super(WSGIStartupPrintingServer, self).bind(family, type, proto)
            host, port = self.socket.getsockname()[:2]
            print "http://%s:%d/" % (host, port)


app = web.application(urls, globals(), autoreload=False)
if __name__ == "__main__":
    web.config.debug = False
    if len(sys.argv) > 1 and sys.argv[1].endswith(':0'):
        patch_dynamic_port()
    app.run()

